Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 c3754a5b 2019-05-10 stsp
27 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
28 d3b82051 2022-07-10 thomas
29 d3b82051 2022-07-10 thomas # Check to see if PLATFORM has a value. PLATFORM is populated when running
30 d3b82051 2022-07-10 thomas # via `./configure && make` but this isn't guaranteed if an individual test is
31 d3b82051 2022-07-10 thomas # run directly, such as `regress/cmdline/tag.sh`. In such cases, PLATFORM
32 d3b82051 2022-07-10 thomas # will be empty, but we still want to use it. Since we test for non-linux
33 d3b82051 2022-07-10 thomas # values, only set PLATFORM if we're running on Linu so that the correct
34 d3b82051 2022-07-10 thomas # commands are used.
35 980b1615 2022-07-11 thomas [ -z "$PLATFORM" -a "$(uname)" = "Linux" ] && PLATFORM="linux"
36 7b67836a 2019-05-10 stsp
37 fa37079f 2021-10-09 thomas date()
38 fa37079f 2021-10-09 thomas {
39 fa37079f 2021-10-09 thomas DATECMD="date"
40 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
41 e8da6c41 2022-07-10 thomas command -v "gdate" >/dev/null 2>&1 && {
42 e8da6c41 2022-07-10 thomas DATECMD="gdate"
43 e8da6c41 2022-07-10 thomas } || {
44 cc5596d8 2022-07-11 thomas echo "Couldn't find gdate is GNU coreutils installed?"
45 e8da6c41 2022-07-10 thomas }
46 e8da6c41 2022-07-10 thomas }
47 c206b220 2021-10-09 thomas command "$DATECMD" "$@"
48 fa37079f 2021-10-09 thomas }
49 fa37079f 2021-10-09 thomas
50 fa37079f 2021-10-09 thomas ln()
51 fa37079f 2021-10-09 thomas {
52 fa37079f 2021-10-09 thomas LNCMD="ln"
53 e8da6c41 2022-07-10 thomas [ "$PLATFORM" != "linux" ] && {
54 e8da6c41 2022-07-10 thomas command -v "gln" >/dev/null 2>&1 && {
55 e8da6c41 2022-07-10 thomas LNCMD="gln"
56 e8da6c41 2022-07-10 thomas } || {
57 cc5596d8 2022-07-11 thomas echo "Couldn't find gln is GNU coreutils installed?"
58 e8da6c41 2022-07-10 thomas }
59 e8da6c41 2022-07-10 thomas }
60 c206b220 2021-10-09 thomas command "$LNCMD" "$@"
61 fa37079f 2021-10-09 thomas }
62 fa37079f 2021-10-09 thomas
63 c206b220 2021-10-09 thomas sed()
64 c206b220 2021-10-09 thomas {
65 c206b220 2021-10-09 thomas SEDCMD="sed"
66 186c23b6 2022-03-08 thomas
67 186c23b6 2022-03-08 thomas # On non-linux systems, the sed command can happily accept "-i ''" as
68 186c23b6 2022-03-08 thomas # a valid command to not save backup files for in-place edits.
69 186c23b6 2022-03-08 thomas # However, on linux, "-i ''" would be treated as "-i" with a blank
70 186c23b6 2022-03-08 thomas # argument, and hence, no file to edit in-place, which is an error.
71 186c23b6 2022-03-08 thomas #
72 186c23b6 2022-03-08 thomas # Therefore, scan the argument list and remove "-i ''", replacing it
73 186c23b6 2022-03-08 thomas # with just "-i".
74 432c637b 2022-07-11 thomas
75 1ff9fea4 2021-11-23 thomas [ "$PLATFORM" = "linux" ] && {
76 432c637b 2022-07-11 thomas for w in "$@"
77 432c637b 2022-07-11 thomas do
78 432c637b 2022-07-11 thomas [ "$w" = "-i" ] && {
79 432c637b 2022-07-11 thomas seen=1
80 432c637b 2022-07-11 thomas continue
81 432c637b 2022-07-11 thomas }
82 432c637b 2022-07-11 thomas
83 432c637b 2022-07-11 thomas [ "$seen" = "1" -a -z "$w" ] && {
84 432c637b 2022-07-11 thomas # Move past -i and ''
85 186c23b6 2022-03-08 thomas shift 2
86 432c637b 2022-07-11 thomas
87 0a046396 2022-07-12 thomas command "$SEDCMD" -i "$@"
88 186c23b6 2022-03-08 thomas return
89 186c23b6 2022-03-08 thomas }
90 186c23b6 2022-03-08 thomas done
91 c206b220 2021-10-09 thomas }
92 0a046396 2022-07-12 thomas command "$SEDCMD" "$@"
93 c206b220 2021-10-09 thomas }
94 fa37079f 2021-10-09 thomas
95 fa37079f 2021-10-09 thomas
96 f6cae3ed 2020-09-13 naddy git_init()
97 0e673013 2019-01-02 stsp {
98 0b2899f8 2019-08-18 stsp git init -q "$1"
99 f60607c8 2021-09-30 thomas
100 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
101 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
102 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
103 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
104 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
105 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
106 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
107 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
108 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
109 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
110 0e673013 2019-01-02 stsp }
111 0e673013 2019-01-02 stsp
112 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
113 b32c4525 2020-01-05 stsp {
114 b32c4525 2020-01-05 stsp local repo="$1"
115 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
116 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
117 b32c4525 2020-01-05 stsp fi
118 b32c4525 2020-01-05 stsp }
119 b32c4525 2020-01-05 stsp
120 f6cae3ed 2020-09-13 naddy git_commit()
121 0e673013 2019-01-02 stsp {
122 0e673013 2019-01-02 stsp local repo="$1"
123 0e673013 2019-01-02 stsp shift
124 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
125 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
126 0e673013 2019-01-02 stsp }
127 0e673013 2019-01-02 stsp
128 f6cae3ed 2020-09-13 naddy git_rm()
129 512f0d0e 2019-01-02 stsp {
130 512f0d0e 2019-01-02 stsp local repo="$1"
131 512f0d0e 2019-01-02 stsp shift
132 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
133 512f0d0e 2019-01-02 stsp }
134 512f0d0e 2019-01-02 stsp
135 f6cae3ed 2020-09-13 naddy git_show_head()
136 9c4b8182 2019-01-02 stsp {
137 9c4b8182 2019-01-02 stsp local repo="$1"
138 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
139 9c4b8182 2019-01-02 stsp }
140 9c4b8182 2019-01-02 stsp
141 f6cae3ed 2020-09-13 naddy git_show_branch_head()
142 db32465d 2020-02-07 stsp {
143 db32465d 2020-02-07 stsp local repo="$1"
144 db32465d 2020-02-07 stsp local branch="$2"
145 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
146 db32465d 2020-02-07 stsp }
147 db32465d 2020-02-07 stsp
148 db32465d 2020-02-07 stsp
149 f6cae3ed 2020-09-13 naddy git_show_author_time()
150 bcb49d15 2019-08-14 stsp {
151 bcb49d15 2019-08-14 stsp local repo="$1"
152 01073a5d 2019-08-22 stsp local object="$2"
153 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
154 bcb49d15 2019-08-14 stsp }
155 bcb49d15 2019-08-14 stsp
156 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
157 8e7bd50a 2019-08-22 stsp {
158 8e7bd50a 2019-08-22 stsp local repo="$1"
159 8e7bd50a 2019-08-22 stsp local tag="$2"
160 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
161 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
162 8e7bd50a 2019-08-22 stsp }
163 8e7bd50a 2019-08-22 stsp
164 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
165 818c7501 2019-07-11 stsp {
166 818c7501 2019-07-11 stsp local repo="$1"
167 70551d57 2020-04-24 stsp local commit="$2"
168 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
169 818c7501 2019-07-11 stsp }
170 818c7501 2019-07-11 stsp
171 f6cae3ed 2020-09-13 naddy git_show_tree()
172 03415a1a 2019-06-02 stsp {
173 03415a1a 2019-06-02 stsp local repo="$1"
174 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
175 03415a1a 2019-06-02 stsp }
176 03415a1a 2019-06-02 stsp
177 f6cae3ed 2020-09-13 naddy trim_obj_id()
178 818c7501 2019-07-11 stsp {
179 9439a990 2020-09-16 naddy local trimcount=$1
180 9439a990 2020-09-16 naddy local id=$2
181 818c7501 2019-07-11 stsp
182 9439a990 2020-09-16 naddy local pat=""
183 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
184 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
185 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
186 818c7501 2019-07-11 stsp done
187 818c7501 2019-07-11 stsp
188 818c7501 2019-07-11 stsp echo ${id%$pat}
189 818c7501 2019-07-11 stsp }
190 818c7501 2019-07-11 stsp
191 f6cae3ed 2020-09-13 naddy git_commit_tree()
192 03415a1a 2019-06-02 stsp {
193 03415a1a 2019-06-02 stsp local repo="$1"
194 03415a1a 2019-06-02 stsp local msg="$2"
195 03415a1a 2019-06-02 stsp local tree="$3"
196 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
197 03415a1a 2019-06-02 stsp }
198 03415a1a 2019-06-02 stsp
199 f0fd0aaf 2021-09-14 stsp git_fsck()
200 f0fd0aaf 2021-09-14 stsp {
201 f0fd0aaf 2021-09-14 stsp local testroot="$1"
202 f0fd0aaf 2021-09-14 stsp local repo="$2"
203 f0fd0aaf 2021-09-14 stsp
204 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
205 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
206 fc414659 2022-04-16 thomas ret=$?
207 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
208 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
209 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
210 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
211 f0fd0aaf 2021-09-14 stsp return 1
212 f0fd0aaf 2021-09-14 stsp fi
213 f0fd0aaf 2021-09-14 stsp
214 f0fd0aaf 2021-09-14 stsp return 0
215 f0fd0aaf 2021-09-14 stsp }
216 f0fd0aaf 2021-09-14 stsp
217 f6cae3ed 2020-09-13 naddy make_test_tree()
218 0e673013 2019-01-02 stsp {
219 0e673013 2019-01-02 stsp repo="$1"
220 0e673013 2019-01-02 stsp
221 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
222 0e673013 2019-01-02 stsp echo beta > $repo/beta
223 0e673013 2019-01-02 stsp mkdir $repo/gamma
224 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
225 0e673013 2019-01-02 stsp mkdir $repo/epsilon
226 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
227 0e673013 2019-01-02 stsp }
228 0e673013 2019-01-02 stsp
229 f6cae3ed 2020-09-13 naddy make_single_file_repo()
230 e7303626 2020-05-14 stsp {
231 e7303626 2020-05-14 stsp repo="$1"
232 e7303626 2020-05-14 stsp file="$2"
233 e7303626 2020-05-14 stsp
234 e7303626 2020-05-14 stsp mkdir $repo
235 e7303626 2020-05-14 stsp git_init $repo
236 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
237 e7303626 2020-05-14 stsp (cd $repo && git add .)
238 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
239 e7303626 2020-05-14 stsp }
240 e7303626 2020-05-14 stsp
241 f6cae3ed 2020-09-13 naddy get_loose_object_path()
242 e7303626 2020-05-14 stsp {
243 e7303626 2020-05-14 stsp local repo="$1"
244 e7303626 2020-05-14 stsp local id="$2"
245 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
246 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
247 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
248 e7303626 2020-05-14 stsp }
249 e7303626 2020-05-14 stsp
250 f6cae3ed 2020-09-13 naddy get_blob_id()
251 3ce1b845 2019-07-15 stsp {
252 3ce1b845 2019-07-15 stsp repo="$1"
253 3ce1b845 2019-07-15 stsp tree_path="$2"
254 3ce1b845 2019-07-15 stsp filename="$3"
255 3ce1b845 2019-07-15 stsp
256 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
257 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
258 3ce1b845 2019-07-15 stsp }
259 3ce1b845 2019-07-15 stsp
260 f6cae3ed 2020-09-13 naddy test_init()
261 0e673013 2019-01-02 stsp {
262 0e673013 2019-01-02 stsp local testname="$1"
263 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
264 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
265 0e673013 2019-01-02 stsp echo "No test name provided" >&2
266 0e673013 2019-01-02 stsp return 1
267 0e673013 2019-01-02 stsp fi
268 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
269 0e673013 2019-01-02 stsp mkdir $testroot/repo
270 0e673013 2019-01-02 stsp git_init $testroot/repo
271 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
272 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
273 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
274 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
275 4a1ddfc2 2019-01-12 stsp fi
276 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
277 0e673013 2019-01-02 stsp echo "$testroot"
278 0e673013 2019-01-02 stsp }
279 0e673013 2019-01-02 stsp
280 f6cae3ed 2020-09-13 naddy test_cleanup()
281 0e673013 2019-01-02 stsp {
282 0e673013 2019-01-02 stsp local testroot="$1"
283 fe7842f5 2019-07-14 stsp
284 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
285 fc414659 2022-04-16 thomas ret=$?
286 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
287 f0fd0aaf 2021-09-14 stsp return $ret
288 fe7842f5 2019-07-14 stsp fi
289 fe7842f5 2019-07-14 stsp
290 0e673013 2019-01-02 stsp rm -rf "$testroot"
291 0e673013 2019-01-02 stsp }
292 0e673013 2019-01-02 stsp
293 f6cae3ed 2020-09-13 naddy test_parseargs()
294 7fb414ae 2020-08-08 stsp {
295 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
296 6c8da0c6 2020-10-03 naddy case $flag in
297 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
298 6c8da0c6 2020-10-03 naddy ;;
299 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
300 6c8da0c6 2020-10-03 naddy ;;
301 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
302 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
303 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
304 6c8da0c6 2020-10-03 naddy exit 2
305 6c8da0c6 2020-10-03 naddy ;;
306 7fb414ae 2020-08-08 stsp esac
307 7fb414ae 2020-08-08 stsp done
308 6c8da0c6 2020-10-03 naddy } >&2
309 7fb414ae 2020-08-08 stsp
310 f6cae3ed 2020-09-13 naddy run_test()
311 0e673013 2019-01-02 stsp {
312 0e673013 2019-01-02 stsp testfunc="$1"
313 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
314 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
315 7fb414ae 2020-08-08 stsp fi
316 0e673013 2019-01-02 stsp $testfunc
317 0e673013 2019-01-02 stsp }
318 0e673013 2019-01-02 stsp
319 f6cae3ed 2020-09-13 naddy test_done()
320 0e673013 2019-01-02 stsp {
321 0e673013 2019-01-02 stsp local testroot="$1"
322 0e673013 2019-01-02 stsp local result="$2"
323 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
324 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
325 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
326 7fb414ae 2020-08-08 stsp echo "ok"
327 7fb414ae 2020-08-08 stsp fi
328 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
329 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
330 3941b73a 2019-05-14 stsp echo "$result"
331 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
332 0e673013 2019-01-02 stsp else
333 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
334 0e673013 2019-01-02 stsp fi
335 0e673013 2019-01-02 stsp }